diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/tif_xfile.cpp ./win32/dependencies/cximage/tif_xfile.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/tif_xfile.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/tif_xfile.cpp	2006-08-24 07:16:02 +0900
@@ -0,0 +1,208 @@
+/*
+ * TIFF file IO, using CxFile.
+ */
+
+#ifdef WIN32
+ #include <windows.h>
+#endif
+#include <stdio.h>
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_TIF
+
+#include "../tiff/tiffiop.h"
+
+#include "xfile.h"
+
+static tsize_t 
+_tiffReadProcEx(thandle_t fd, tdata_t buf, tsize_t size)
+{
+	return ((CxFile*)fd)->Read(buf, 1, size);
+}
+
+static tsize_t
+_tiffWriteProcEx(thandle_t fd, tdata_t buf, tsize_t size)
+{
+	return ((CxFile*)fd)->Write(buf, 1, size);
+}
+
+static toff_t
+_tiffSeekProcEx(thandle_t fd, toff_t off, int whence)
+{
+	if ( off == 0xFFFFFFFF ) 
+		return 0xFFFFFFFF;
+	if (!((CxFile*)fd)->Seek(off, whence))
+		return 0xFFFFFFFF;
+	if (whence == SEEK_SET)
+		return off;
+
+	return (toff_t)((CxFile*)fd)->Tell();
+}
+
+// Return nonzero if error
+static int
+_tiffCloseProcEx(thandle_t fd)
+{
+//	return !((CxFile*)fd)->Close(); // "//" needed for memory files <DP>
+	return 0;
+}
+
+#include <sys/stat.h>
+
+static toff_t
+_tiffSizeProcEx(thandle_t fd)
+{
+	return ((CxFile*)fd)->Size();
+}
+
+static int
+_tiffMapProcEx(thandle_t fd, tdata_t* pbase, toff_t* psize)
+{
+	return (0);
+}
+
+static void
+_tiffUnmapProcEx(thandle_t fd, tdata_t base, toff_t size)
+{
+}
+
+// Open a TIFF file descriptor for read/writing.
+/*
+TIFF*
+TIFFOpen(const char* name, const char* mode)
+{
+	static const char module[] = "TIFFOpen";
+   FILE* stream = fopen(name, mode);
+	if (stream == NULL) 
+   {
+		TIFFError(module, "%s: Cannot open", name);
+		return NULL;
+	}
+	return (TIFFFdOpen((int)stream, name, mode));
+}
+*/
+
+TIFF*
+_TIFFFdOpen(int fd, const char* name, const char* mode)
+{
+	TIFF* tif;
+
+	tif = TIFFClientOpen(name, mode,
+	    (thandle_t) fd,
+	    _tiffReadProcEx, _tiffWriteProcEx, _tiffSeekProcEx, _tiffCloseProcEx,
+	    _tiffSizeProcEx, _tiffMapProcEx, _tiffUnmapProcEx);
+	if (tif)
+		tif->tif_fd = fd;
+	return (tif);
+}
+
+extern "C" TIFF* _TIFFOpenEx(CxFile* stream, const char* mode)
+{
+	return (_TIFFFdOpen((int)stream, "TIFF IMAGE", mode));
+}
+
+#ifdef __GNUC__
+extern	char* malloc();
+extern	char* realloc();
+#else
+#include <malloc.h>
+#endif
+
+tdata_t
+_TIFFmalloc(tsize_t s)
+{
+	return (malloc((size_t) s));
+}
+
+void
+_TIFFfree(tdata_t p)
+{
+	free(p);
+}
+
+tdata_t
+_TIFFrealloc(tdata_t p, tsize_t s)
+{
+	return (realloc(p, (size_t) s));
+}
+
+void
+_TIFFmemset(tdata_t p, int v, tsize_t c)
+{
+	memset(p, v, (size_t) c);
+}
+
+void
+_TIFFmemcpy(tdata_t d, const tdata_t s, tsize_t c)
+{
+	memcpy(d, s, (size_t) c);
+}
+
+int
+_TIFFmemcmp(const tdata_t p1, const tdata_t p2, tsize_t c)
+{
+	return (memcmp(p1, p2, (size_t) c));
+}
+
+static void
+Win32WarningHandler(const char* module, const char* fmt, va_list ap)
+{
+#ifdef _DEBUG
+#if (!defined(_CONSOLE) && defined(WIN32))
+	LPTSTR szTitle;
+	LPTSTR szTmp;
+	LPCTSTR szTitleText = "%s Warning";
+	LPCTSTR szDefaultModule = "TIFFLIB";
+	szTmp = (module == NULL) ? (LPTSTR)szDefaultModule : (LPTSTR)module;
+	if ((szTitle = (LPTSTR)LocalAlloc(LMEM_FIXED, (lstrlen(szTmp) +
+			lstrlen(szTitleText) + lstrlen(fmt) + 128)*sizeof(TCHAR))) == NULL)
+		return;
+	wsprintf(szTitle, szTitleText, szTmp);
+	szTmp = szTitle + (lstrlen(szTitle)+2)*sizeof(TCHAR);
+	wvsprintf(szTmp, fmt, ap);
+	MessageBox(GetFocus(), szTmp, szTitle, MB_OK | MB_ICONINFORMATION);
+	LocalFree(szTitle);
+	return;
+#else
+	if (module != NULL)
+		fprintf(stderr, "%s: ", module);
+	fprintf(stderr, "Warning, ");
+	vfprintf(stderr, fmt, ap);
+	fprintf(stderr, ".\n");
+#endif
+#endif
+}
+TIFFErrorHandler _TIFFwarningHandler = Win32WarningHandler;
+
+static void
+Win32ErrorHandler(const char* module, const char* fmt, va_list ap)
+{
+#ifdef _DEBUG
+#if (!defined(_CONSOLE) && defined(WIN32))
+	LPTSTR szTitle;
+	LPTSTR szTmp;
+	LPCTSTR szTitleText = "%s Error";
+	LPCTSTR szDefaultModule = "TIFFLIB";
+	szTmp = (module == NULL) ? (LPTSTR)szDefaultModule : (LPTSTR)module;
+	if ((szTitle = (LPTSTR)LocalAlloc(LMEM_FIXED, (lstrlen(szTmp) +
+			lstrlen(szTitleText) + lstrlen(fmt) + 128)*sizeof(TCHAR))) == NULL)
+		return;
+	wsprintf(szTitle, szTitleText, szTmp);
+	szTmp = szTitle + (lstrlen(szTitle)+2)*sizeof(TCHAR);
+	wvsprintf(szTmp, fmt, ap);
+	MessageBox(GetFocus(), szTmp, szTitle, MB_OK | MB_ICONEXCLAMATION);
+	LocalFree(szTitle);
+	return;
+#else
+	if (module != NULL)
+		fprintf(stderr, "%s: ", module);
+	vfprintf(stderr, fmt, ap);
+	fprintf(stderr, ".\n");
+#endif
+#endif
+}
+TIFFErrorHandler _TIFFerrorHandler = Win32ErrorHandler;
+
+#endif
+
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/xfile.h ./win32/dependencies/cximage/xfile.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/xfile.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/xfile.h	2006-08-24 07:16:02 +0900
@@ -0,0 +1,76 @@
+/*
+ * File:	xfile.h
+ * Purpose:	General Purpose File Class 
+ */
+/*
+  --------------------------------------------------------------------------------
+
+	COPYRIGHT NOTICE, DISCLAIMER, and LICENSE:
+
+	CxFile (c)  11/May/2002 Davide Pizzolato - www.xdp.it
+	CxFile version 2.00 23/Aug/2002
+	
+	Special thanks to Chris Shearer Cooper for new features, enhancements and bugfixes
+
+	Covered code is provided under this license on an "as is" basis, without warranty
+	of any kind, either expressed or implied, including, without limitation, warranties
+	that the covered code is free of defects, merchantable, fit for a particular purpose
+	or non-infringing. The entire risk as to the quality and performance of the covered
+	code is with you. Should any covered code prove defective in any respect, you (not
+	the initial developer or any other contributor) assume the cost of any necessary
+	servicing, repair or correction. This disclaimer of warranty constitutes an essential
+	part of this license. No use of any covered code is authorized hereunder except under
+	this disclaimer.
+
+	Permission is hereby granted to use, copy, modify, and distribute this
+	source code, or portions hereof, for any purpose, including commercial applications,
+	freely and without fee, subject to the following restrictions: 
+
+	1. The origin of this software must not be misrepresented; you must not
+	claim that you wrote the original software. If you use this software
+	in a product, an acknowledgment in the product documentation would be
+	appreciated but is not required.
+
+	2. Altered source versions must be plainly marked as such, and must not be
+	misrepresented as being the original software.
+
+	3. This notice may not be removed or altered from any source distribution.
+  --------------------------------------------------------------------------------
+ */
+#if !defined(__xfile_h)
+#define __xfile_h
+
+#ifdef WIN32
+ #include <windows.h>
+#endif
+
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "ximadef.h"
+
+class DLL_EXP CxFile
+{
+public:
+	CxFile(void) { };
+	virtual ~CxFile() { };
+
+	virtual bool	Close() = 0;
+	virtual size_t	Read(void *buffer, size_t size, size_t count) = 0;
+	virtual size_t	Write(const void *buffer, size_t size, size_t count) = 0;
+	virtual bool	Seek(long offset, int origin) = 0;
+	virtual long	Tell() = 0;
+	virtual long	Size() = 0;
+	virtual bool	Flush() = 0;
+	virtual bool	Eof() = 0;
+	virtual long	Error() = 0;
+	virtual bool	PutC(unsigned char c)
+		{
+		// Default implementation
+		size_t nWrote = Write(&c, 1, 1);
+		return (bool)(nWrote == 1);
+		}
+	virtual long	GetC() = 0;
+};
+
+#endif //__xfile_h
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximabmp.cpp ./win32/dependencies/cximage/ximabmp.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximabmp.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximabmp.cpp	2006-08-24 07:16:02 +0900
@@ -0,0 +1,361 @@
+/*
+ * File:	ximabmp.cpp
+ * Purpose:	Platform Independent BMP Image Class Loader and Writer
+ * 07/Aug/2001 Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximabmp.h"
+
+#if CXIMAGE_SUPPORT_BMP
+
+#include "ximaiter.h" 
+
+////////////////////////////////////////////////////////////////////////////////
+#if CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageBMP::Encode(CxFile * hFile)
+{
+
+	if (EncodeSafeCheck(hFile)) return false;
+
+	BITMAPFILEHEADER	hdr;
+
+	hdr.bfType = 0x4d42;   // 'BM' WINDOWS_BITMAP_SIGNATURE
+	hdr.bfSize = GetSize() + 14 /*sizeof(BITMAPFILEHEADER)*/;
+	hdr.bfReserved1 = hdr.bfReserved2 = 0;
+	hdr.bfOffBits = 14 /*sizeof(BITMAPFILEHEADER)*/ + head.biSize + GetPaletteSize();
+
+	 //copy attributes
+	memcpy(pDib,&head,sizeof(BITMAPINFOHEADER));
+    // Write the file header
+	hFile->Write(&hdr,min(14,sizeof(BITMAPFILEHEADER)),1);
+    // Write the DIB header and the pixels
+	hFile->Write(pDib,GetSize(),1);
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif //CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+#if CXIMAGE_SUPPORT_DECODE
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageBMP::Decode(CxFile * hFile)
+{
+	if (hFile == NULL) return false;
+
+	BITMAPFILEHEADER   bf;
+	DWORD off = hFile->Tell(); //<CSC>
+  try {
+    if (hFile->Read(&bf,min(14,sizeof(bf)),1)==0) throw "Not a BMP";
+    if (bf.bfType != BFT_BITMAP) { //do we have a RC HEADER?
+        bf.bfOffBits = 0L;
+        hFile->Seek(off,SEEK_SET);
+    }
+
+	BITMAPINFOHEADER bmpHeader;
+	if (!DibReadBitmapInfo(hFile,&bmpHeader)) throw "Error reading BMP info";
+	DWORD dwCompression=bmpHeader.biCompression;
+	DWORD dwBitCount=bmpHeader.biBitCount; //preserve for BI_BITFIELDS compression <Thomas Ernst>
+	bool bIsOldBmp = bmpHeader.biSize == sizeof(BITMAPCOREHEADER);
+
+	bool bTopDownDib = bmpHeader.biHeight<0; //<Flanders> check if it's a top-down bitmap
+	if (bTopDownDib) bmpHeader.biHeight=-bmpHeader.biHeight;
+
+	if (info.nEscape == -1) {
+		// Return output dimensions only
+		head.biWidth = bmpHeader.biWidth;
+		head.biHeight = bmpHeader.biHeight;
+		throw "output dimensions returned";
+	}
+
+	if (!Create(bmpHeader.biWidth,bmpHeader.biHeight,bmpHeader.biBitCount,CXIMAGE_FORMAT_BMP))
+		throw "Can't allocate memory";
+
+	head.biXPelsPerMeter = bmpHeader.biXPelsPerMeter;
+	head.biYPelsPerMeter = bmpHeader.biYPelsPerMeter;
+	info.xDPI = (long) floor(bmpHeader.biXPelsPerMeter * 254.0 / 10000.0 + 0.5);
+	info.yDPI = (long) floor(bmpHeader.biYPelsPerMeter * 254.0 / 10000.0 + 0.5);
+
+	if (info.nEscape) throw "Cancelled"; // <vho> - cancel decoding
+
+    RGBQUAD *pRgb = GetPalette();
+    if (pRgb){
+        if (bIsOldBmp){
+             // convert a old color table (3 byte entries) to a new
+             // color table (4 byte entries)
+            hFile->Read((void*)pRgb,DibNumColors(&bmpHeader) * sizeof(RGBTRIPLE),1);
+            for (int i=DibNumColors(&head)-1; i>=0; i--){
+                pRgb[i].rgbRed      = ((RGBTRIPLE *)pRgb)[i].rgbtRed;
+                pRgb[i].rgbBlue     = ((RGBTRIPLE *)pRgb)[i].rgbtBlue;
+                pRgb[i].rgbGreen    = ((RGBTRIPLE *)pRgb)[i].rgbtGreen;
+                pRgb[i].rgbReserved = (BYTE)0;
+            }
+        } else {
+            hFile->Read((void*)pRgb,DibNumColors(&bmpHeader) * sizeof(RGBQUAD),1);
+			//force rgbReserved=0, to avoid problems with some WinXp bitmaps
+			for (unsigned int i=0; i<head.biClrUsed; i++) pRgb[i].rgbReserved=0;
+        }
+    }
+
+	if (info.nEscape) throw "Cancelled"; // <vho> - cancel decoding
+
+	switch (dwBitCount) {
+		case 32 :
+			if (bf.bfOffBits != 0L) hFile->Seek(off + bf.bfOffBits,SEEK_SET);
+			if (dwCompression == BI_BITFIELDS || dwCompression == BI_RGB){
+				long imagesize=4*head.biHeight*head.biWidth;
+				BYTE* buff32=(BYTE*)malloc(imagesize);
+				if (buff32){
+					hFile->Read(buff32, imagesize,1); // read in the pixels
+					Bitfield2RGB(buff32,0,0,0,32);
+					free(buff32);
+				} else throw "can't allocate memory";
+			} else throw "unknown compression";
+			break;
+		case 24 :
+			if (bf.bfOffBits != 0L) hFile->Seek(off + bf.bfOffBits,SEEK_SET);
+			if (dwCompression == BI_RGB){
+				hFile->Read(info.pImage, head.biSizeImage,1); // read in the pixels
+			} else throw "unknown compression";
+			break;
+		case 16 :
+		{
+			DWORD bfmask[3];
+			if (dwCompression == BI_BITFIELDS)
+			{
+				hFile->Read(bfmask, 12, 1);
+			} else {
+				bfmask[0]=0x7C00; bfmask[1]=0x3E0; bfmask[2]=0x1F; //RGB555
+			}
+			// bf.bfOffBits required after the bitfield mask <Cui Ying Jie>
+			if (bf.bfOffBits != 0L) hFile->Seek(off + bf.bfOffBits,SEEK_SET);
+			// read in the pixels
+			hFile->Read(info.pImage, head.biHeight*((head.biWidth+1)/2)*4,1);
+			// transform into RGB
+			Bitfield2RGB(info.pImage,(WORD)bfmask[0],(WORD)bfmask[1],(WORD)bfmask[2],16);
+			break;
+		}
+		case 8 :
+		case 4 :
+		case 1 :
+		if (bf.bfOffBits != 0L) hFile->Seek(off + bf.bfOffBits,SEEK_SET);
+		switch (dwCompression) {
+			case BI_RGB :
+				hFile->Read(info.pImage, head.biSizeImage,1); // read in the pixels
+				break;
+			case BI_RLE4 :
+			{
+				BYTE status_byte = 0;
+				BYTE second_byte = 0;
+				int scanline = 0;
+				int bits = 0;
+				BOOL low_nibble = FALSE;
+				CImageIterator iter(this);
+
+				for (BOOL bContinue = TRUE; bContinue;) {
+					hFile->Read(&status_byte, sizeof(BYTE), 1);
+					switch (status_byte) {
+						case RLE_COMMAND :
+							hFile->Read(&status_byte, sizeof(BYTE), 1);
+							switch (status_byte) {
+								case RLE_ENDOFLINE :
+									bits = 0;
+									scanline++;
+									low_nibble = FALSE;
+									break;
+								case RLE_ENDOFBITMAP :
+									bContinue=FALSE;
+									break;
+								case RLE_DELTA :
+								{
+									// read the delta values
+									BYTE delta_x;
+									BYTE delta_y;
+									hFile->Read(&delta_x, sizeof(BYTE), 1);
+									hFile->Read(&delta_y, sizeof(BYTE), 1);
+									// apply them
+									bits       += delta_x / 2;
+									scanline   += delta_y;
+									break;
+								}
+								default :
+									hFile->Read(&second_byte, sizeof(BYTE), 1);
+									BYTE *sline = iter.GetRow(scanline);
+									for (int i = 0; i < status_byte; i++) {
+										if (low_nibble) {
+											if ((DWORD)(sline+bits) < (DWORD)(info.pImage+head.biSizeImage)){
+												*(sline + bits) |=  (second_byte & 0x0F);
+											}
+											if (i != status_byte - 1)
+												hFile->Read(&second_byte, sizeof(BYTE), 1);
+											bits++;
+										} else {
+											if ((DWORD)(sline+bits) < (DWORD)(info.pImage+head.biSizeImage)){
+												*(sline + bits) = (BYTE)(second_byte & 0xF0);
+											}
+										}
+										low_nibble = !low_nibble;
+									}
+									if ((((status_byte+1) >> 1) & 1 )== 1)
+										hFile->Read(&second_byte, sizeof(BYTE), 1);												
+									break;
+							};
+							break;
+						default :
+						{
+							BYTE *sline = iter.GetRow(scanline);
+							hFile->Read(&second_byte, sizeof(BYTE), 1);
+							for (unsigned i = 0; i < status_byte; i++) {
+								if (low_nibble) {
+									if ((DWORD)(sline+bits) < (DWORD)(info.pImage+head.biSizeImage)){
+										*(sline + bits) |= (second_byte & 0x0F);
+									}
+									bits++;
+								} else {
+									if ((DWORD)(sline+bits) < (DWORD)(info.pImage+head.biSizeImage)){
+										*(sline + bits) = (BYTE)(second_byte & 0xF0);
+									}
+								}				
+								low_nibble = !low_nibble;
+							}
+						}
+						break;
+					};
+				}
+				break;
+			}
+			case BI_RLE8 :
+			{
+				BYTE status_byte = 0;
+				BYTE second_byte = 0;
+				int scanline = 0;
+				int bits = 0;
+				CImageIterator iter(this);
+
+				for (BOOL bContinue = TRUE; bContinue; ) {
+					hFile->Read(&status_byte, sizeof(BYTE), 1);
+					switch (status_byte) {
+						case RLE_COMMAND :
+							hFile->Read(&status_byte, sizeof(BYTE), 1);
+							switch (status_byte) {
+								case RLE_ENDOFLINE :
+									bits = 0;
+									scanline++;
+									break;
+								case RLE_ENDOFBITMAP :
+									bContinue=FALSE;
+									break;
+								case RLE_DELTA :
+								{
+									// read the delta values
+									BYTE delta_x;
+									BYTE delta_y;
+									hFile->Read(&delta_x, sizeof(BYTE), 1);
+									hFile->Read(&delta_y, sizeof(BYTE), 1);
+									// apply them
+									bits     += delta_x;
+									scanline += delta_y;
+									break;
+								}
+								default :
+									hFile->Read((void *)(iter.GetRow(scanline) + bits), sizeof(BYTE) * status_byte, 1);
+									// align run length to even number of bytes 
+									if ((status_byte & 1) == 1)
+										hFile->Read(&second_byte, sizeof(BYTE), 1);												
+									bits += status_byte;													
+									break;								
+							};
+							break;
+						default :
+							BYTE *sline = iter.GetRow(scanline);
+							hFile->Read(&second_byte, sizeof(BYTE), 1);
+							for (unsigned i = 0; i < status_byte; i++) {
+								if ((DWORD)bits<info.dwEffWidth){
+									*(sline + bits) = second_byte;
+									bits++;					
+								} else {
+									bContinue = FALSE;
+									break;
+								}
+							}
+							break;
+					};
+				}
+				break;
+			}
+			default :								
+				throw "compression type not supported";
+		}
+	}
+
+	if (bTopDownDib) Flip(); //<Flanders>
+
+  } catch (char *message) {
+	strncpy(info.szLastError,message,255);
+	if (info.nEscape==-1) return true;
+	return false;
+  }
+    return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/*  ReadDibBitmapInfo()
+ *
+ *  Will read a file in DIB format and return a global HANDLE to its
+ *  BITMAPINFO.  This function will work with both "old" and "new"
+ *  bitmap formats, but will always return a "new" BITMAPINFO.
+ */
+bool CxImageBMP::DibReadBitmapInfo(CxFile* fh, BITMAPINFOHEADER *pdib)
+{
+	if ((fh==NULL)||(pdib==NULL)) return false;
+
+    if (fh->Read(pdib,sizeof(BITMAPINFOHEADER),1)==0) return false;
+
+    BITMAPCOREHEADER   bc;
+
+    switch (pdib->biSize) // what type of bitmap info is this?
+    {
+        case sizeof(BITMAPINFOHEADER):
+            break;
+
+		case 64: //sizeof(OS2_BMP_HEADER):
+            fh->Seek((long)(64 - sizeof(BITMAPINFOHEADER)),SEEK_CUR);
+			break;
+
+        case sizeof(BITMAPCOREHEADER):
+            bc = *(BITMAPCOREHEADER*)pdib;
+            pdib->biSize               = bc.bcSize;
+            pdib->biWidth              = (DWORD)bc.bcWidth;
+            pdib->biHeight             = (DWORD)bc.bcHeight;
+            pdib->biPlanes             =  bc.bcPlanes;
+            pdib->biBitCount           =  bc.bcBitCount;
+            pdib->biCompression        = BI_RGB;
+            pdib->biSizeImage          = 0;
+            pdib->biXPelsPerMeter      = 0;
+            pdib->biYPelsPerMeter      = 0;
+            pdib->biClrUsed            = 0;
+            pdib->biClrImportant       = 0;
+
+			fh->Seek((long)(sizeof(BITMAPCOREHEADER)-sizeof(BITMAPINFOHEADER)), SEEK_CUR);
+
+            break;
+        default:
+			//give a last chance
+			 if (pdib->biSize>(sizeof(BITMAPINFOHEADER))&&
+				(pdib->biSizeImage==(unsigned long)(pdib->biHeight*((((pdib->biBitCount*pdib->biWidth)+31)/32)*4)))&&
+				(pdib->biPlanes==1)&&(pdib->biCompression==BI_RGB)&&(pdib->biClrUsed==0))
+			 {
+	             fh->Seek((long)(pdib->biSize - sizeof(BITMAPINFOHEADER)),SEEK_CUR);
+				 break;
+			 }
+			return false;
+    }
+
+    FixBitmapInfo(pdib);
+
+    return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif //CXIMAGE_SUPPORT_DECODE
+////////////////////////////////////////////////////////////////////////////////
+#endif 	// CXIMAGE_SUPPORT_BMP
+////////////////////////////////////////////////////////////////////////////////
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximabmp.h ./win32/dependencies/cximage/ximabmp.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximabmp.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximabmp.h	2006-08-24 07:16:02 +0900
@@ -0,0 +1,79 @@
+/*
+ * File:	ximabmp.h
+ * Purpose:	BMP Image Class Loader and Writer
+ */
+/* ==========================================================
+ * CxImageBMP (c) 07/Aug/2001 Davide Pizzolato - www.xdp.it
+ * For conditions of distribution and use, see copyright notice in ximage.h
+ *
+ * Special thanks to Troels Knakkergaard for new features, enhancements and bugfixes
+ *
+ * original CImageBMP  and CImageIterator implementation are:
+ * Copyright:	(c) 1995, Alejandro Aguilar Sierra <asierra(at)servidor(dot)unam(dot)mx>
+ *
+ * ==========================================================
+ */
+
+#if !defined(__ximaBMP_h)
+#define __ximaBMP_h
+
+#include "ximage.h"
+
+const int RLE_COMMAND     = 0;
+const int RLE_ENDOFLINE   = 0;
+const int RLE_ENDOFBITMAP = 1;
+const int RLE_DELTA       = 2;
+
+#if !defined(BI_RLE8)
+ #define BI_RLE8  1L
+#endif
+#if !defined(BI_RLE4)
+ #define BI_RLE4  2L
+#endif
+
+#if CXIMAGE_SUPPORT_BMP
+
+class CxImageBMP: public CxImage
+{
+public:
+	CxImageBMP(): CxImage(CXIMAGE_FORMAT_BMP) {};
+
+	bool Decode(CxFile * hFile);
+	bool Decode(FILE *hFile) { CxIOFile file(hFile); return Decode(&file); }
+
+#if CXIMAGE_SUPPORT_ENCODE
+	bool Encode(CxFile * hFile);
+	bool Encode(FILE *hFile) { CxIOFile file(hFile); return Encode(&file); }
+#endif // CXIMAGE_SUPPORT_ENCODE
+
+protected:
+	bool DibReadBitmapInfo(CxFile* fh, BITMAPINFOHEADER *pdib);
+};
+
+#define BFT_ICON   0x4349   /* 'IC' */
+#define BFT_BITMAP 0x4d42   /* 'BM' */
+#define BFT_CURSOR 0x5450   /* 'PT' */
+
+#ifndef WIDTHBYTES
+#define WIDTHBYTES(i)           ((unsigned)((i+31)&(~31))/8)  /* ULONG aligned ! */
+#endif
+
+#endif
+
+#define DibWidthBytesN(lpbi, n) (UINT)WIDTHBYTES((UINT)(lpbi)->biWidth * (UINT)(n))
+#define DibWidthBytes(lpbi)     DibWidthBytesN(lpbi, (lpbi)->biBitCount)
+
+#define DibSizeImage(lpbi)      ((lpbi)->biSizeImage == 0 \
+                                    ? ((DWORD)(UINT)DibWidthBytes(lpbi) * (DWORD)(UINT)(lpbi)->biHeight) \
+                                    : (lpbi)->biSizeImage)
+
+#define DibNumColors(lpbi)      ((lpbi)->biClrUsed == 0 && (lpbi)->biBitCount <= 8 \
+                                    ? (int)(1 << (int)(lpbi)->biBitCount)          \
+                                    : (int)(lpbi)->biClrUsed)
+
+#define FixBitmapInfo(lpbi)     if ((lpbi)->biSizeImage == 0)                 \
+												(lpbi)->biSizeImage = DibSizeImage(lpbi); \
+                                if ((lpbi)->biClrUsed == 0)                   \
+                                    (lpbi)->biClrUsed = DibNumColors(lpbi);   \
+
+#endif
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximacfg.h ./win32/dependencies/cximage/ximacfg.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximacfg.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximacfg.h	2006-08-24 07:16:02 +0900
@@ -0,0 +1,52 @@
+#if !defined(__ximaCFG_h)
+#define __ximaCFG_h
+
+/////////////////////////////////////////////////////////////////////////////
+// CxImage supported features
+#define CXIMAGE_SUPPORT_ALPHA          1
+#define CXIMAGE_SUPPORT_SELECTION      1
+#define CXIMAGE_SUPPORT_TRANSFORMATION 1
+#define CXIMAGE_SUPPORT_DSP            1
+#define CXIMAGE_SUPPORT_LAYERS		   1
+#define CXIMAGE_SUPPORT_INTERPOLATION  1
+
+#define CXIMAGE_SUPPORT_DECODE	1
+#define CXIMAGE_SUPPORT_ENCODE	1		//<vho><T.Peck>
+#define	CXIMAGE_SUPPORT_WINDOWS 1
+#define	CXIMAGE_SUPPORT_WINCE   0		//<T.Peck>
+
+/////////////////////////////////////////////////////////////////////////////
+// CxImage supported formats
+#define CXIMAGE_SUPPORT_BMP 1
+#define CXIMAGE_SUPPORT_GIF 1
+#define CXIMAGE_SUPPORT_JPG 0
+#define CXIMAGE_SUPPORT_PNG 0
+#define CXIMAGE_SUPPORT_MNG 0
+#define CXIMAGE_SUPPORT_ICO 1
+#define CXIMAGE_SUPPORT_TIF 0
+#define CXIMAGE_SUPPORT_TGA 1
+#define CXIMAGE_SUPPORT_PCX 1
+#define CXIMAGE_SUPPORT_WBMP 1
+#define CXIMAGE_SUPPORT_WMF 1
+#define CXIMAGE_SUPPORT_J2K 0		// Beta, use JP2
+#define CXIMAGE_SUPPORT_JBG 0		// GPL'd see ../jbig/copying.txt & ../jbig/patents.htm
+
+#define CXIMAGE_SUPPORT_JP2 0
+#define CXIMAGE_SUPPORT_JPC 0
+#define CXIMAGE_SUPPORT_PGX 0
+#define CXIMAGE_SUPPORT_PNM 0
+#define CXIMAGE_SUPPORT_RAS 0
+
+
+/////////////////////////////////////////////////////////////////////////////
+#define	CXIMAGE_MAX_MEMORY 256000000
+
+#define CXIMAGE_ERR_NOFILE "null file handler"
+#define CXIMAGE_ERR_NOIMAGE "null image!!!"
+
+/////////////////////////////////////////////////////////////////////////////
+//color to grey mapping <H. Muelner> <jurgene>
+//#define RGB2GRAY(r,g,b) (((b)*114 + (g)*587 + (r)*299)/1000)
+#define RGB2GRAY(r,g,b) (((b)*117 + (g)*601 + (r)*306) >> 10)
+
+#endif
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximadef.h ./win32/dependencies/cximage/ximadef.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximadef.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximadef.h	2006-08-24 07:16:02 +0900
@@ -0,0 +1,197 @@
+#if !defined(__ximadefs_h)
+#define __ximadefs_h
+
+#include "ximacfg.h"
+
+#if defined(_AFXDLL)||defined(_USRDLL)
+ #define DLL_EXP __declspec(dllexport)
+#elif defined(_MSC_VER)&&(_MSC_VER<1200)
+ #define DLL_EXP __declspec(dllimport)
+#else
+ #define DLL_EXP
+#endif
+
+#if CXIMAGE_SUPPORT_JP2 || CXIMAGE_SUPPORT_JPC || CXIMAGE_SUPPORT_PGX || CXIMAGE_SUPPORT_PNM || CXIMAGE_SUPPORT_RAS
+ #define CXIMAGE_SUPPORT_JASPER 1
+#else
+ #define CXIMAGE_SUPPORT_JASPER 0
+#endif
+
+#if CXIMAGE_SUPPORT_DSP
+#undef CXIMAGE_SUPPORT_TRANSFORMATION
+ #define CXIMAGE_SUPPORT_TRANSFORMATION 1
+#endif
+
+#if CXIMAGE_SUPPORT_TRANSFORMATION || CXIMAGE_SUPPORT_TIF || CXIMAGE_SUPPORT_TGA || CXIMAGE_SUPPORT_BMP || CXIMAGE_SUPPORT_WINDOWS
+ #define CXIMAGE_SUPPORT_BASICTRANSFORMATIONS 1
+#endif
+
+#if CXIMAGE_SUPPORT_DSP || CXIMAGE_SUPPORT_TRANSFORMATION
+#undef CXIMAGE_SUPPORT_INTERPOLATION
+ #define CXIMAGE_SUPPORT_INTERPOLATION 1
+#endif
+
+#if CXIMAGE_SUPPORT_WINCE
+ #undef CXIMAGE_SUPPORT_WMF
+ #define CXIMAGE_SUPPORT_WMF 0
+ #undef	CXIMAGE_SUPPORT_WINDOWS
+ #define	CXIMAGE_SUPPORT_WINDOWS 0
+#endif
+
+#ifndef WIN32
+ #undef CXIMAGE_SUPPORT_WINDOWS
+ #define CXIMAGE_SUPPORT_WINDOWS 0
+#endif
+
+#ifndef min
+#define min(a,b) (((a)<(b))?(a):(b))
+#endif
+#ifndef max
+#define max(a,b) (((a)>(b))?(a):(b))
+#endif
+
+#ifndef PI
+ #define PI 3.141592653589793f
+#endif
+
+
+#ifdef WIN32
+#include <windows.h>
+#include <tchar.h>
+#endif
+
+#include <stdio.h>
+#include <math.h>
+
+
+#ifdef __BORLANDC__
+
+#ifndef _COMPLEX_DEFINED
+
+typedef struct tagcomplex {
+	double x,y;
+} _complex;
+
+#endif
+
+#define _cabs(c) sqrt(c.x*c.x+c.y*c.y)
+
+#endif
+
+
+#ifndef WIN32
+
+#include <stdlib.h>
+#include <string.h>
+#include <ctype.h>
+
+typedef unsigned char  BYTE;
+typedef unsigned short WORD;
+typedef unsigned long  DWORD;
+typedef unsigned int   UINT;
+
+typedef DWORD          COLORREF;
+typedef unsigned int   HANDLE;
+typedef void*          HRGN;
+
+#ifndef BOOL
+#define	BOOL bool
+#endif
+
+#ifndef TRUE
+#define	TRUE true
+#endif
+
+#ifndef FALSE
+#define	FALSE false
+#endif
+
+#ifndef TCHAR
+#define TCHAR char
+#define _T
+#endif
+
+typedef struct tagRECT
+{
+	long    left;
+	long    top;
+	long    right;
+	long    bottom;
+} RECT;
+
+typedef struct tagPOINT
+{
+	long  x;
+	long  y;
+} POINT;
+
+typedef struct tagRGBQUAD {
+	BYTE    rgbBlue;
+	BYTE    rgbGreen;
+	BYTE    rgbRed;
+	BYTE    rgbReserved;
+} RGBQUAD;
+
+#pragma pack(1)
+
+typedef struct tagBITMAPINFOHEADER{
+	DWORD      biSize;
+	long       biWidth;
+	long       biHeight;
+	WORD       biPlanes;
+	WORD       biBitCount;
+	DWORD      biCompression;
+	DWORD      biSizeImage;
+	long       biXPelsPerMeter;
+	long       biYPelsPerMeter;
+	DWORD      biClrUsed;
+	DWORD      biClrImportant;
+} BITMAPINFOHEADER;
+
+typedef struct tagBITMAPFILEHEADER {
+	WORD    bfType;
+	DWORD   bfSize;
+	WORD    bfReserved1;
+	WORD    bfReserved2;
+	DWORD   bfOffBits;
+} BITMAPFILEHEADER;
+
+typedef struct tagBITMAPCOREHEADER {
+	DWORD   bcSize;
+	WORD    bcWidth;
+	WORD    bcHeight;
+	WORD    bcPlanes;
+	WORD    bcBitCount;
+} BITMAPCOREHEADER;
+
+typedef struct tagRGBTRIPLE {
+	BYTE    rgbtBlue;
+	BYTE    rgbtGreen;
+	BYTE    rgbtRed;
+} RGBTRIPLE;
+
+#pragma pack()
+
+#define BI_RGB        0L
+#define BI_RLE8       1L
+#define BI_RLE4       2L
+#define BI_BITFIELDS  3L
+
+#define GetRValue(rgb)      ((BYTE)(rgb))
+#define GetGValue(rgb)      ((BYTE)(((WORD)(rgb)) >> 8))
+#define GetBValue(rgb)      ((BYTE)((rgb)>>16))
+#define RGB(r,g,b)          ((COLORREF)(((BYTE)(r)|((WORD)((BYTE)(g))<<8))|(((DWORD)(BYTE)(b))<<16)))
+
+#ifndef _COMPLEX_DEFINED
+
+typedef struct tagcomplex {
+	double x,y;
+} _complex;
+
+#endif
+
+#define _cabs(c) sqrt(c.x*c.x+c.y*c.y)
+
+#endif
+
+#endif //__ximadefs
